<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<HTML>

<HEAD>
<TITLE>Projets</TITLE>
<META NAME="GENERATOR" CONTENT="Arachnophilia Version 2.1">
<META NAME="FORMATTER" CONTENT="Arachnophilia Version 2.1">
</HEAD>

<BODY BGCOLOR="#0000ff" BACKGROUND="img/clouds.jpg" TEXT="#ffff00" LINK="#80ff80" VLINK="#c0c0c0" ALINK="#ff0000">

<CENTER><FONT SIZE="+3" color="#FF8000"><B>Projets</B></FONT></CENTER>
<p>
<FONT FACE="Helvetica,Arial"><b>
J'ai prévu 3 ou 4 projets individuels, mais les deux premiers font partie d'un projet double, réalisé en la plus stricte collaboration entre deux étudiants. Le dernier ou les deux derniers peuvent également être réalisé(s) par deux personnes.  Si, au bout de quelques semaines vous trouvez des difficultés pour choisir un projet, vos pouvez toujours proposer un autre vous-même.
<p>

Mes projets sont relativement ambitieux, et nécessitent beaucoup de temps. (Je ne dirais pas qu'il soient difficiles, mais fatigants sans doute...) Quelques autres offres (notamment à ISMRA) font partie d'un ou plusieurs projets globaux réalisés par le Labo. Les miens sont absolument indépendants. Chaque approche a ses avantages et ses handicaps. L'avantage d'un projet indépendant est de pouvoir vraiment montrer de l'initiative, de l'inventivité, et de faire de choses très personnelles. Il est d'ailleurs plus facile d'évaluer l'étudiant, on sait mieux ce qu'il a fait vraiment lui-même. Par contre, ce style est adapté plutôt aux personnes avec une personnalité forte et stable, car on risque de s'égarer...

</b></FONT>
<p>
<p>
<FONT SIZE="+1">

<H1>Les sujets :</H1>

<a name="vectr">
<OL>
<LI><FONT COLOR=#ff8040><B>Un logiciel portable, écrit en Java, de vectorisation des bitmaps. </B></FONT>
<BR>
<p>
<font color="#80ff60" size=+1>
<img src="../icons/starroll.gif" align=abscenter> &nbsp;
(Ce projet est déjà pris par Pierre Godquin et Vincent Sellier.)</font>
<p>

Jusqu'aujourd'hui il est très difficile de trouver un logiciel public capable de transformer des bitmaps en dessin vectoriel (et de générer les fichiers DXF, Metafiles X ou Windows, éventuellement les commandes PostScript). Si on trouve quelque chose, ceci d'habitude est un logiciel fermé, et même parmi les logiciels commerciaux on trouve des vectoriseurs très mauvais, comme Corel Trace. L'Internet est pollué par des versions de démonstration qui servent à rien, mais on peut les utiliser pour s'inspirer. Je propose de construire un paquetage portable, modulaire et ouvert (possible d'être integré à une autre application) qui fait des choses suivantes :
<UL>
<LI>Renforce les contours, élimine les "miettes" par quelques techniques standard de filtrage, et de seuillage. 
<LI>Toujours par le filtrage et/ou des techniques morphologiques (érosion etc.) récupere les contours d'une qualité raisonnable.

<LI>Optionnellement exploite d'autres techniques de récupération des zones/contours, comme la méthode des contours actifs (<I>snakes</I>), ou la méthode <I>watershed</I>.

<LI>La vraie vectorisation - suivi des contours (en tenant compte des branchements et des cycles), et construction d'une liste des sommets. Tout doit être paramétrable, on doit pouvoir jouer avec la vitesse/consommation de mémoire/qualité du résultat.

<li>Interprétation, génération d'un document vectoriel. Ceci doit offrir quelques choix concernant le format de sortie. Au moins il faut savoir générer le format vectoriel portable, comme le DXF, et le PostScript.
</UL>

Les algorithmes de traitement des bitmaps sont bien connus, documentés, et implantés dans maintes paquetages disponibles partout (p. ex. dans Khoros). Leur conversion en Java ne doit pas poser des problèmes. Le suivi du contour n'est pas trop difficile non plus, bien que sa programmation ne se fera pas en une heure. Les dessins texturés, avec gradients, etc. seront plus problématiques, mais nos ambitions ne sont pas exorbitantes. Un tel logiciel sera très utile aux autres, localement et partout sur l'Internet, à condition que sa réalisation soit décente. 
<p>

<LI><FONT COLOR=#ff8040><B>Animation de la<I>Tapisserie de la Reine Mathilde</I>.</FONT></B>
<BR>
Il s'agit de donner un peu de vie aux héros morts il y a 900 ans...<br>
En fait, ce projet est le <I>field-test</I> du logiciel de vectorisation. On prendra quelques fragments scannés de la Tapisserie de Bayeux, par exemple <A HREF="img/baye.jpg">ceci</A>, et on écrira d'abord un scénario : comment peut on faire bouger quelques objets sur la scène. La tâche n'est pas très difficile, les dessins sont simples et le fond relativement homogène. Ensuite :
<UL>
<LI>On vectorisera le dessin et on séparera les objets.
<LI>Un objet récupéré sera placé dans un éditeur intéractif, ou pompé dans un script d'animation ; une suite de dessins sera généré.
<LI>Chaque dessin sera rendu de manière à ne pas modifier le style de la Tapisserie. Les dessins laids et tordus doivent rester comme ça ! Ces opérations dépendent de la qualité de la vectorisation, l'objet doit être "malléable", pas trop complexe. Le rendu doit s'occuper des zones homogènes et des lignes (contours), mas ces contours - si on regarde bien les images - possèdent également une certaine texture.
<BR>
<FONT COLOR=#ff80ff>La gestion des textures semble être la partie la plus difficile de ce projet combiné !
</FONT>
<p>

<CENTER><IMG SRC="img/barys.gif" ALT=""></CENTER>

<p>
<LI>&Agrave; la fin on génère une suite de dessins et on les combine dans un GIF animé ou un MPEG. Il faut prevoir la création de quelques centaines de dessins, alors une certaine automatisation sera indispensable.

</UL>
<p>
<p>

<!-- +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ -->
<hr width=70% size=8 noshade>
<p>


<a name="schflow">
<p>
<LI> (ou 3 <b>et</b> 4): <FONT COLOR=#ff8040><B>Un logiciel - environnement de développement visuelle style Dataflow, integré au paquetage <FONT COLOR=#80ff00>PLT-Scheme</FONT></B> de Rice University.</FONT>
<BR>
<FONT COLOR=#80ff00>Ceci est un exercice en programmation et en design d'une architecture logicielle</FONT> destiné à ceux qui ne sont pas alérgiques à la programmation en Scheme. Ce n'est pas vraiment un projet d'imagerie, mais inclut la construction d'une interface visuelle non-standard, et beaucoup de gestion des objets graphiques<br>

Qu'est-ce que le <I>Dataflow</I>? De manière très succinte : c'est un protocol de programmation plus proche de la programmation functionnelle que de l'impérative, qui est piloté par les données. Au lieu de taper le texte, le programmeur "assemble" son programme comme on construit un circuit électronique complexe. Le programme est composé de blocs, où chaque bloc possède un certaine nombre de "connecteurs" d'entrée et de sortie. Les entrées reçoivent des données émis par d'autres blocs, et quand toutes les données sont accessibles, le bloc démarre et produit ses résultats de sortie qui sont pompés vers d'autres blocs. Ce style a été longtemps utilisé dans le domaine de traitement du signal, dans la simulation des architectures parallèles,  et dans d'autres logiciels scientifiques, <FONT COLOR=#ff6060>mais il faut savoir qu'il devient de plus en plus populaire dans la programmation générale !
</FONT> On le trouve toujours dans des logiciels scientifiques comme Matlab, Scilab ou Khoros, ou plus récemment dans LabView et ses collègues (HiQ), mais aussi dans le domaine plus universelle, comme dans l'environnement JavaStudio de Sun. 
Ce qui est primordial ici ce sont deux propriétés de ce style, dont la seconde est essentielle pour nous :
<UL>
<LI>Les "chemins" des données sont indépendants, ils remplacent le (mono-thread) flux de contrôle, et ceci rend le style Dataflow bien adapté au parallélisme.
<LI>Les programmes comme ensembles de boîtiers fonctionnels sont des <FONT size=+1 COLOR=#ff8000>entités visuelles</FONT>, programmés/composés - répétons - comme on fait un circuit électronique complexe - on place les blocs sur une surface et on les connecte.
</UL>
Regardez <A HREF="Datexa.html">cette page</A> pour voir quelques exemples. <p>
Quelques détails comme le choix du langage d'implantation et quelques détails techniques se trouvent sur <A HREF="DIScheme.html">cette page</A>.
<p>

<FONT COLOR=#80ff00 size=+1>Je pense que ce projet doit également être fait à deux.</FONT> On peut le découper aisément en deux modules : la partie interface graphique, gestion des diagrammes, chemins, intéractions, etc., et la partie "sémantique", génération/compilation (et exécution) du code. Si ce projet est terminé avec succès, le travail devra être <FONT COLOR=#80ff00>publié</FONT>.

</OL>

<p>
Et voici une référence sur les
<a href="http://cuisung.unige.ch/Visual/Freeman/VL.html" target=_top>langages visuels</a>.

<p><hr><p>

<FONT COLOR=#ff8080 size=+1><b>
Dernier mot officiel, et très sérieux !<br>
Je ne veux personne qui envisagerait de prendre le projet et d'apparaître vers la fin du semestre avec les résultats (quelconques)! Je prévois un rendez-vous au moins une fois par semaine, de préférence deux fois. On va commencer à rédiger le rapport presque immédiatemment. J'aimerais que le projet soit publié sur l'Internet et rendu accessible aux autres, et en ce qui concerne le troisième/quatrième sujet, ceci <U>peut</U> en principe aboutir à une <i>vraie</i> publication (p. ex. dans <I>Lisp and Symbolic Programming</I>, sinon dans les cahiers du GREYC, éventuellement présentée à un forum extérieur.)

</b>
</FONT>

<p>
<hr width=80% size=8 noshade>
<p>

</FONT>
<p>
<H1>Décidez-vous vite mais pas trop vite !</H1>

<p>
Le retour à la <A HREF="dpage.html">page DESS principale.</A>

</BODY>

</HTML>
